Index: contrib/ntp/include/ntp_stdlib.h
===================================================================
--- contrib/ntp/include/ntp_stdlib.h	(版本 314126)
+++ contrib/ntp/include/ntp_stdlib.h	(版本 316722)
@@ -105,21 +105,23 @@
 /* emalloc.c */
 #ifndef EREALLOC_CALLSITE	/* ntp_malloc.h defines */
 extern	void *	ereallocz	(void *, size_t, size_t, int);
-extern	void *	oreallocarray	(void *optr, size_t nmemb, size_t size);
+extern	void *	oreallocarrayxz	(void *optr, size_t nmemb, size_t size, size_t extra);
 #define	erealloczsite(p, n, o, z, f, l) ereallocz((p), (n), (o), (z))
 #define	emalloc(n)		ereallocz(NULL, (n), 0, FALSE)
 #define	emalloc_zero(c)		ereallocz(NULL, (c), 0, TRUE)
 #define	erealloc(p, c)		ereallocz((p), (c), 0, FALSE)
 #define erealloc_zero(p, n, o)	ereallocz((p), (n), (o), TRUE)
-#define ereallocarray(p, n, s)	oreallocarray((p), (n), (s))
-#define eallocarray(n, s)	oreallocarray(NULL, (n), (s))
+#define ereallocarray(p, n, s)	oreallocarrayxz((p), (n), (s), 0)
+#define eallocarray(n, s)	oreallocarrayxz(NULL, (n), (s), 0)
+#define ereallocarrayxz(p, n, s, x)	oreallocarrayxz((p), (n), (s), (x))
+#define eallocarrayxz(n, s, x)	oreallocarrayxz(NULL, (n), (s), (x))
 extern	char *	estrdup_impl(const char *);
 #define	estrdup(s)		estrdup_impl(s)
 #else
 extern	void *	ereallocz	(void *, size_t, size_t, int,
 				 const char *, int);
-extern	void *	oreallocarray	(void *optr, size_t nmemb, size_t size,
-				 const char *, int);
+extern	void *	oreallocarrayxz	(void *optr, size_t nmemb, size_t size,
+				 size_t extra, const char *, int);
 #define erealloczsite		ereallocz
 #define	emalloc(c)		ereallocz(NULL, (c), 0, FALSE, \
 					  __FILE__, __LINE__)
@@ -129,10 +131,14 @@
 					  __FILE__, __LINE__)
 #define	erealloc_zero(p, n, o)	ereallocz((p), (n), (o), TRUE, \
 					  __FILE__, __LINE__)
-#define ereallocarray(p, n, s)	oreallocarray((p), (n), (s), \
+#define ereallocarray(p, n, s)	oreallocarrayxz((p), (n), (s), 0, \
 					  __FILE__, __LINE__)
-#define eallocarray(n, s)	oreallocarray(NULL, (n), (s), \
+#define eallocarray(n, s)	oreallocarrayxz(NULL, (n), (s), 0, \
 					  __FILE__, __LINE__)
+#define ereallocarrayxz(p, n, s, x)	oreallocarrayxz((p), (n), (s), (x), \
+					  __FILE__, __LINE__)
+#define eallocarrayxz(n, s, x)	oreallocarrayxz(NULL, (n), (s), (x), \
+					  __FILE__, __LINE__)
 extern	char *	estrdup_impl(const char *, const char *, int);
 #define	estrdup(s) estrdup_impl((s), __FILE__, __LINE__)
 #endif
Index: contrib/ntp/include/ntpd.h
===================================================================
--- contrib/ntp/include/ntpd.h	(版本 314126)
+++ contrib/ntp/include/ntpd.h	(版本 316722)
@@ -321,6 +321,8 @@
 
 /* ntp_config.c */
 extern char const *	progname;
+extern int saved_argc;
+extern char **saved_argv;
 extern char	*sys_phone[];		/* ACTS phone numbers */
 #if defined(HAVE_SCHED_SETSCHEDULER)
 extern int	config_priority_override;
@@ -487,12 +489,13 @@
 extern u_long 	sys_epoch;		/* last clock update time */
 extern keyid_t	sys_private;		/* private value for session seed */
 extern int	sys_manycastserver;	/* respond to manycast client pkts */
+extern int	sys_maxclock;		/* maximum survivors */
 extern int	sys_minclock;		/* minimum survivors */
 extern int	sys_minsane;		/* minimum candidates */
 extern int	sys_floor;		/* cluster stratum floor */
 extern int	sys_ceiling;		/* cluster stratum ceiling */
 extern u_char	sys_ttl[MAX_TTL];	/* ttl mapping vector */
-extern int	sys_ttlmax;		/* max ttl mapping vector index */
+extern u_int	sys_ttlmax;		/* max ttl mapping vector index */
 
 /*
  * Statistics counters
Index: contrib/ntp/include/ssl_applink.c
===================================================================
--- contrib/ntp/include/ssl_applink.c	(版本 314126)
+++ contrib/ntp/include/ssl_applink.c	(版本 316722)
@@ -10,8 +10,13 @@
 # ifdef _MSC_VER
 #  pragma warning(push)
 #  pragma warning(disable: 4152)
+#  ifndef OPENSSL_NO_AUTOLINK
+#   include "msvc_ssl_autolib.h"
+#  endif
 # endif
-# include <openssl/applink.c>
+# if OPENSSL_VERSION_NUMBER < 0x10100000L
+#  include <openssl/applink.c>
+# endif
 # ifdef _MSC_VER
 #  pragma warning(pop)
 # endif
@@ -25,20 +30,30 @@
 void *wrap_dbg_malloc(size_t s, const char *f, int l);
 void *wrap_dbg_realloc(void *p, size_t s, const char *f, int l);
 void wrap_dbg_free(void *p);
+void wrap_dbg_free_ex(void *p, const char *f, int l);
 #endif
 
 
 #if defined(OPENSSL) && defined(SYS_WINNT)
+
 void ssl_applink(void);
 
 void
 ssl_applink(void)
 {
-#ifdef WRAP_DBG_MALLOC
+#if OPENSSL_VERSION_NUMBER >= 0x10100000L
+#   ifdef WRAP_DBG_MALLOC
+	CRYPTO_set_mem_functions(wrap_dbg_malloc, wrap_dbg_realloc, wrap_dbg_free_ex);
+#   else
+	OPENSSL_malloc_init();
+#   endif
+#else
+#   ifdef WRAP_DBG_MALLOC
 	CRYPTO_set_mem_ex_functions(wrap_dbg_malloc, wrap_dbg_realloc, wrap_dbg_free);
-#else
+#   else
 	CRYPTO_malloc_init();
-#endif
+#   endif
+#endif /* OpenSSL version cascade */
 }
 #else	/* !OPENSSL || !SYS_WINNT */
 #define ssl_applink()	do {} while (0)
@@ -71,4 +86,11 @@
 {
 	_free_dbg(p, _NORMAL_BLOCK);
 }
+
+void wrap_dbg_free_ex(void *p, const char *f, int l)
+{
+	(void)f;
+	(void)l;
+	_free_dbg(p, _NORMAL_BLOCK);
+}
 #endif	/* WRAP_DBG_MALLOC */
Index: contrib/ntp/lib/isc/inet_pton.c
===================================================================
--- contrib/ntp/lib/isc/inet_pton.c	(版本 314126)
+++ contrib/ntp/lib/isc/inet_pton.c	(版本 316722)
@@ -170,7 +170,7 @@
 				colonp = tp;
 				continue;
 			}
-			if (tp + NS_INT16SZ > endp)
+			if (NS_INT16SZ > endp - tp)
 				return (0);
 			*tp++ = (unsigned char) (val >> 8) & 0xff;
 			*tp++ = (unsigned char) val & 0xff;
@@ -178,7 +178,7 @@
 			val = 0;
 			continue;
 		}
-		if (ch == '.' && ((tp + NS_INADDRSZ) <= endp) &&
+		if (ch == '.' && (NS_INADDRSZ <= endp - tp) &&
 		    inet_pton4(curtok, tp) > 0) {
 			tp += NS_INADDRSZ;
 			seen_xdigits = 0;
@@ -187,7 +187,7 @@
 		return (0);
 	}
 	if (seen_xdigits) {
-		if (tp + NS_INT16SZ > endp)
+		if (NS_INT16SZ > endp - tp)
 			return (0);
 		*tp++ = (unsigned char) (val >> 8) & 0xff;
 		*tp++ = (unsigned char) val & 0xff;
Index: contrib/ntp/libntp/audio.c
===================================================================
--- contrib/ntp/libntp/audio.c	(版本 314126)
+++ contrib/ntp/libntp/audio.c	(版本 316722)
@@ -46,6 +46,19 @@
 # include <ctype.h>
 #endif
 
+
+/* 
+ * 4.4BSD-Lite switched to an unsigned long ioctl arg.  Detect common
+ * derivatives here, and apply that type. To make the following code
+ * less verbose we make a proper typedef.
+ * The joy of IOCTL programming...
+ */
+# if defined(__FreeBSD__) || defined(__APPLE__) || defined(__NetBSD__) || defined __OpenBSD__
+typedef unsigned long ioctl_arg_T;
+#else
+typedef int ioctl_arg_T;
+#endif
+
 /*
  * Global variables
  */
@@ -54,13 +67,14 @@
 #endif /* HAVE_SYS_AUDIOIO_H */
 #ifdef PCM_STYLE_SOUND
 # define INIT_FILE "/etc/ntp.audio"
-int agc =	SOUND_MIXER_WRITE_RECLEV; /* or IGAIN or LINE */
-int audiomonitor =     SOUND_MIXER_WRITE_VOLUME; /* or OGAIN */
-int devmask = 0;
-int recmask = 0;
-char cf_c_dev[100], cf_i_dev[100], cf_agc[100], cf_monitor[100];
 
-const char *m_names[SOUND_MIXER_NRDEVICES] = SOUND_DEVICE_NAMES;
+static ioctl_arg_T agc		= SOUND_MIXER_WRITE_RECLEV; /* or IGAIN or LINE */
+static ioctl_arg_T audiomonitor	= SOUND_MIXER_WRITE_VOLUME; /* or OGAIN */
+static int devmask = 0;
+static int recmask = 0;
+static char cf_c_dev[100], cf_i_dev[100], cf_agc[100], cf_monitor[100];
+
+static const char *m_names[SOUND_MIXER_NRDEVICES] = SOUND_DEVICE_NAMES;
 #else /* not PCM_STYLE_SOUND */
 static struct audio_info info;	/* audio device info */
 #endif /* not PCM_STYLE_SOUND */
@@ -347,7 +361,7 @@
 # ifdef HAVE_SYS_AUDIOIO_H
 	info.record.buffer_size = bufsiz;
 # endif /* HAVE_SYS_AUDIOIO_H */
-	rval = ioctl(ctl_fd, (int)AUDIO_SETINFO, (char *)&info);
+	rval = ioctl(ctl_fd, AUDIO_SETINFO, (char *)&info);
 	if (rval < 0) {
 		msyslog(LOG_ERR, "audio: invalid control device parameters");
 		close(ctl_fd);
@@ -448,7 +462,7 @@
 		o_port = port;
 	}
 #else /* not PCM_STYLE_SOUND */
-	ioctl(ctl_fd, (int)AUDIO_GETINFO, (char *)&info);
+	ioctl(ctl_fd, AUDIO_GETINFO, (char *)&info);
 	info.record.encoding = AUDIO_ENCODING_ULAW;
 	info.record.error = 0;
 	info.record.gain = gain;
@@ -456,7 +470,7 @@
 		o_mongain = info.monitor_gain = mongain;
 	if (o_port != port)
 		o_port = info.record.port = port;
-	rval = ioctl(ctl_fd, (int)AUDIO_SETINFO, (char *)&info);
+	rval = ioctl(ctl_fd, AUDIO_SETINFO, (char *)&info);
 	if (rval < 0) {
 		msyslog(LOG_ERR, "audio_gain: %m");
 		return (rval);
@@ -485,11 +499,11 @@
 
 #else /* not PCM_STYLE_SOUND */
 # ifdef HAVE_SYS_AUDIOIO_H
-	ioctl(ctl_fd, (int)AUDIO_GETDEV, &device);
+	ioctl(ctl_fd, AUDIO_GETDEV, &device);
 	printf("audio: name %s, version %s, config %s\n",
 	    device.name, device.version, device.config);
 # endif /* HAVE_SYS_AUDIOIO_H */
-	ioctl(ctl_fd, (int)AUDIO_GETINFO, (char *)&info);
+	ioctl(ctl_fd, AUDIO_GETINFO, (char *)&info);
 	printf(
 	    "audio: rate %d, chan %d, prec %d, code %d, gain %d, mon %d, port %d\n",
 	    info.record.sample_rate, info.record.channels,
Index: contrib/ntp/libntp/emalloc.c
===================================================================
--- contrib/ntp/libntp/emalloc.c	(版本 314126)
+++ contrib/ntp/libntp/emalloc.c	(版本 316722)
@@ -83,10 +83,11 @@
 #define MUL_NO_OVERFLOW	((size_t)1 << (sizeof(size_t) * 4))
 
 void *
-oreallocarray(
+oreallocarrayxz(
 	void *optr,
 	size_t nmemb,
-	size_t size
+	size_t size,
+	size_t extra
 #ifdef EREALLOC_CALLSITE		/* ntp_malloc.h */
 	,
 	const char *	file,
@@ -106,9 +107,9 @@
 		exit(1);
 	}
 #ifndef EREALLOC_CALLSITE
-	return ereallocz(optr, (size * nmemb), 0, FALSE);
+	return ereallocz(optr, extra + (size * nmemb), 0, TRUE);
 #else
-	return ereallocz(optr, (size * nmemb), 0, FALSE, file, line);
+	return ereallocz(optr, extra + (size * nmemb), 0, TRUE, file, line);
 #endif
 }
 
Index: contrib/ntp/libntp/recvbuff.c
===================================================================
--- contrib/ntp/libntp/recvbuff.c	(版本 314126)
+++ contrib/ntp/libntp/recvbuff.c	(版本 316722)
@@ -85,7 +85,7 @@
 	buffer_shortfall = 0;
 
 #ifndef DEBUG
-	bufp = emalloc_zero(abuf * sizeof(*bufp));
+	bufp = eallocarray(abuf, sizeof(*bufp));
 #endif
 
 	for (i = 0; i < abuf; i++) {
Index: contrib/ntp/libntp/work_fork.c
===================================================================
--- contrib/ntp/libntp/work_fork.c	(版本 314126)
+++ contrib/ntp/libntp/work_fork.c	(版本 316722)
@@ -24,6 +24,8 @@
 	int			worker_process;
 	addremove_io_fd_func	addremove_io_fd;
 static	volatile int		worker_sighup_received;
+int	saved_argc = 0;
+char	**saved_argv;
 
 /* === function prototypes === */
 static	void		fork_blocking_child(blocking_child *);
@@ -31,6 +33,62 @@
 static	void		send_worker_home_atexit(void);
 static	void		cleanup_after_child(blocking_child *);
 
+/* === I/O helpers === */
+/* Since we have signals enabled, there's a good chance that blocking IO
+ * via pipe suffers from EINTR -- and this goes for both directions.
+ * The next two wrappers will loop until either all the data is written
+ * or read, plus handling the EOF condition on read. They may return
+ * zero if no data was transferred at all, and effectively every return
+ * value that differs from the given transfer length signifies an error
+ * condition.
+ */
+
+static size_t
+netread(
+	int		fd,
+	void *		vb,
+	size_t		l
+	)
+{
+	char *		b = vb;
+	ssize_t		r;
+
+	while (l) {
+		r = read(fd, b, l);
+		if (r > 0) {
+			l -= r;
+			b += r;
+		} else if (r == 0 || errno != EINTR) {
+			l = 0;
+		}
+	}
+	return (size_t)(b - (char *)vb);
+}
+
+
+static size_t
+netwrite(
+	int		fd,
+	const void *	vb,
+	size_t		l
+	)
+{
+	const char *	b = vb;
+	ssize_t		w;
+
+	while (l) {
+		w = write(fd, b, l);
+		if (w > 0) {
+			l -= w;
+			b += w;
+		} else if (errno != EINTR) {
+			l = 0;
+		}
+	}
+	return (size_t)(b - (const char *)vb);
+}
+
+
 /* === functions === */
 /*
  * exit_worker()
@@ -200,8 +258,8 @@
 	void *			data
 	)
 {
-	int octets;
-	int rc;
+	size_t	octets;
+	size_t	rc;
 
 	DEBUG_REQUIRE(hdr != NULL);
 	DEBUG_REQUIRE(data != NULL);
@@ -213,23 +271,18 @@
 	}
 
 	octets = sizeof(*hdr);
-	rc = write(c->req_write_pipe, hdr, octets);
+	rc = netwrite(c->req_write_pipe, hdr, octets);
 
 	if (rc == octets) {
 		octets = hdr->octets - sizeof(*hdr);
-		rc = write(c->req_write_pipe, data, octets);
-
+		rc = netwrite(c->req_write_pipe, data, octets);
 		if (rc == octets)
 			return 0;
 	}
 
-	if (rc < 0)
-		msyslog(LOG_ERR,
-			"send_blocking_req_internal: pipe write: %m");
-	else
-		msyslog(LOG_ERR,
-			"send_blocking_req_internal: short write %d of %d",
-			rc, octets);
+	msyslog(LOG_ERR,
+		"send_blocking_req_internal: short write (%zu of %zu), %m",
+		rc, octets);
 
 	/* Fatal error.  Clean up the child process.  */
 	req_child_exit(c);
@@ -244,41 +297,32 @@
 {
 	blocking_pipe_header	hdr;
 	blocking_pipe_header *	req;
-	int			rc;
-	long			octets;
+	size_t			rc;
+	size_t			octets;
 
 	DEBUG_REQUIRE(-1 != c->req_read_pipe);
 
 	req = NULL;
+	rc = netread(c->req_read_pipe, &hdr, sizeof(hdr));
 
-	do {
-		rc = read(c->req_read_pipe, &hdr, sizeof(hdr));
-	} while (rc < 0 && EINTR == errno);
-
-	if (rc < 0) {
-		msyslog(LOG_ERR,
-			"receive_blocking_req_internal: pipe read %m");
-	} else if (0 == rc) {
+	if (0 == rc) {
 		TRACE(4, ("parent closed request pipe, child %d terminating\n",
 			  c->pid));
 	} else if (rc != sizeof(hdr)) {
 		msyslog(LOG_ERR,
-			"receive_blocking_req_internal: short header read %d of %lu",
-			rc, (u_long)sizeof(hdr));
+			"receive_blocking_req_internal: short header read (%zu of %zu), %m",
+			rc, sizeof(hdr));
 	} else {
 		INSIST(sizeof(hdr) < hdr.octets && hdr.octets < 4 * 1024);
 		req = emalloc(hdr.octets);
 		memcpy(req, &hdr, sizeof(*req));
 		octets = hdr.octets - sizeof(hdr);
-		rc = read(c->req_read_pipe, (char *)req + sizeof(*req),
-			  octets);
+		rc = netread(c->req_read_pipe, (char *)(req + 1),
+			     octets);
 
-		if (rc < 0)
+		if (rc != octets)
 			msyslog(LOG_ERR,
-				"receive_blocking_req_internal: pipe data read %m");
-		else if (rc != octets)
-			msyslog(LOG_ERR,
-				"receive_blocking_req_internal: short read %d of %ld",
+				"receive_blocking_req_internal: short read (%zu of %zu), %m",
 				rc, octets);
 		else if (BLOCKING_REQ_MAGIC != req->magic_sig)
 			msyslog(LOG_ERR,
@@ -301,24 +345,20 @@
 	blocking_pipe_header *	resp
 	)
 {
-	long	octets;
-	int	rc;
+	size_t	octets;
+	size_t	rc;
 
 	DEBUG_REQUIRE(-1 != c->resp_write_pipe);
 
 	octets = resp->octets;
-	rc = write(c->resp_write_pipe, resp, octets);
+	rc = netwrite(c->resp_write_pipe, resp, octets);
 	free(resp);
 
 	if (octets == rc)
 		return 0;
 
-	if (rc < 0)
-		TRACE(1, ("send_blocking_resp_internal: pipe write %m\n"));
-	else
-		TRACE(1, ("send_blocking_resp_internal: short write %d of %ld\n",
-			  rc, octets));
-
+	TRACE(1, ("send_blocking_resp_internal: short write (%zu of %zu), %m\n",
+		  rc, octets));
 	return -1;
 }
 
@@ -330,21 +370,19 @@
 {
 	blocking_pipe_header	hdr;
 	blocking_pipe_header *	resp;
-	int			rc;
-	long			octets;
+	size_t			rc;
+	size_t			octets;
 
 	DEBUG_REQUIRE(c->resp_read_pipe != -1);
 
 	resp = NULL;
-	rc = read(c->resp_read_pipe, &hdr, sizeof(hdr));
+	rc = netread(c->resp_read_pipe, &hdr, sizeof(hdr));
 
-	if (rc < 0) {
-		TRACE(1, ("receive_blocking_resp_internal: pipe read %m\n"));
-	} else if (0 == rc) {
+	if (0 == rc) {
 		/* this is the normal child exited indication */
 	} else if (rc != sizeof(hdr)) {
-		TRACE(1, ("receive_blocking_resp_internal: short header read %d of %lu\n",
-			  rc, (u_long)sizeof(hdr)));
+		TRACE(1, ("receive_blocking_resp_internal: short header read (%zu of %zu), %m\n",
+			  rc, sizeof(hdr)));
 	} else if (BLOCKING_RESP_MAGIC != hdr.magic_sig) {
 		TRACE(1, ("receive_blocking_resp_internal: header mismatch (0x%x)\n",
 			  hdr.magic_sig));
@@ -354,14 +392,11 @@
 		resp = emalloc(hdr.octets);
 		memcpy(resp, &hdr, sizeof(*resp));
 		octets = hdr.octets - sizeof(hdr);
-		rc = read(c->resp_read_pipe,
-			  (char *)resp + sizeof(*resp),
-			  octets);
+		rc = netread(c->resp_read_pipe, (char *)(resp + 1),
+			     octets);
 
-		if (rc < 0)
-			TRACE(1, ("receive_blocking_resp_internal: pipe data read %m\n"));
-		else if (rc < octets)
-			TRACE(1, ("receive_blocking_resp_internal: short read %d of %ld\n",
+		if (rc != octets)
+			TRACE(1, ("receive_blocking_resp_internal: short read (%zu of %zu), %m\n",
 				  rc, octets));
 		else
 			return resp;
@@ -368,10 +403,10 @@
 	}
 
 	cleanup_after_child(c);
-
+	
 	if (resp != NULL)
 		free(resp);
-
+	
 	return NULL;
 }
 
@@ -503,6 +538,22 @@
 	worker_process = TRUE;
 
 	/*
+	 * Change the process name of the child to avoid confusion
+	 * about ntpd trunning twice.
+	 */
+	if (saved_argc != 0) {
+		int argcc;
+		int argvlen = 0;
+		/* Clear argv */
+		for (argcc = 0; argcc < saved_argc; argcc++) {
+			int l = strlen(saved_argv[argcc]);
+			argvlen += l + 1;
+			memset(saved_argv[argcc], 0, l);
+		}
+		strlcpy(saved_argv[0], "ntpd: asynchronous dns resolver", argvlen);
+	}
+
+	/*
 	 * In the child, close all files except stdin, stdout, stderr,
 	 * and the two child ends of the pipes.
 	 */
Index: contrib/ntp/libparse/clk_trimtsip.c
===================================================================
--- contrib/ntp/libparse/clk_trimtsip.c	(版本 314126)
+++ contrib/ntp/libparse/clk_trimtsip.c	(版本 316722)
@@ -250,10 +250,10 @@
 		    {
 		    case CMD_RCURTIME:
 			    {			/* GPS time */
-				    l_fp secs;
-				    int   week = getshort((unsigned char *)&mb(4));
-				    l_fp utcoffset;
-				    l_fp gpstime;
+				    l_fp  secs;
+				    u_int week = getshort((unsigned char *)&mb(4));
+				    l_fp  utcoffset;
+				    l_fp  gpstime;
 
 				    bp = &mb(0);
 				    if (fetch_ieee754(&bp, IEEE_SINGLE, &secs, trim_offsets) != IEEE_OK)
Index: contrib/ntp/ntpd/ntpd.c
===================================================================
--- contrib/ntp/ntpd/ntpd.c	(版本 314126)
+++ contrib/ntp/ntpd/ntpd.c	(版本 316722)
@@ -230,8 +230,10 @@
 # endif	/* !DEBUG */
 #endif	/* !SIM && !SYS_WINNT */
 
+#ifndef WORK_FORK
 int	saved_argc;
 char **	saved_argv;
+#endif
 
 #ifndef SIM
 int		ntpdmain		(int, char **);
Index: contrib/ntp/ntpd/refclock_datum.c
===================================================================
--- contrib/ntp/ntpd/refclock_datum.c	(版本 314126)
+++ contrib/ntp/ntpd/refclock_datum.c	(版本 316722)
@@ -485,7 +485,7 @@
 	struct recvbuf *rbufp
 	)
 {
-	int i;
+	int i, nb;
 	l_fp tstmp;
 	struct peer *p;
 	struct datum_pts_unit *datum_pts;
@@ -526,7 +526,8 @@
 	** received to reduce the jitter.
 	*/
 
-	if (datum_pts->nbytes == 0) {
+	nb = datum_pts->nbytes;
+	if (nb == 0) {
 		datum_pts->lastrec = rbufp->recv_time;
 	}
 
@@ -533,15 +534,15 @@
 	/*
 	** Increment our count to the number of bytes received so far. Return if we
 	** haven't gotten all seven bytes yet.
+	** [Sec 3388] make sure we do not overrun the buffer.
+	** TODO: what to do with excessive bytes, if we ever get them?
 	*/
-
-	for (i=0; i<dpend; i++) {
-		datum_pts->retbuf[datum_pts->nbytes+i] = dpt[i];
+	for (i=0; (i < dpend) && (nb < sizeof(datum_pts->retbuf)); i++, nb++) {
+		datum_pts->retbuf[nb] = dpt[i];
 	}
-
-	datum_pts->nbytes += dpend;
-
-	if (datum_pts->nbytes != 7) {
+	datum_pts->nbytes = nb;
+	
+	if (nb < 7) {
 		return;
 	}
 
Index: contrib/ntp/ntpd/refclock_nmea.c
===================================================================
--- contrib/ntp/ntpd/refclock_nmea.c	(版本 314126)
+++ contrib/ntp/ntpd/refclock_nmea.c	(版本 316722)
@@ -810,9 +810,6 @@
 	ZERO(tofs);
 	ZERO(date);
 	ZERO(gpsw);
-	sentence = 0;	// Should never be needed.
-	rc_date = 0;	// Should never be needed.
-	rc_time = 0;	// Should never be needed.
 
 	/* 
 	 * Read the timecode and timestamp, then initialise field
Index: contrib/ntp/ntpdc/ntpdc.1ntpdcmdoc
===================================================================
--- contrib/ntp/ntpdc/ntpdc.1ntpdcmdoc	(版本 314126)
+++ contrib/ntp/ntpdc/ntpdc.1ntpdcmdoc	(版本 316722)
@@ -1,9 +1,9 @@
-.Dd November 21 2016
+.Dd March 21 2017
 .Dt NTPDC 1ntpdcmdoc User Commands
 .Os
 .\"  EDIT THIS FILE WITH CAUTION  (ntpdc-opts.mdoc)
 .\"
-.\"  It has been AutoGen-ed  November 21, 2016 at 08:02:35 AM by AutoGen 5.18.5
+.\"  It has been AutoGen-ed  March 21, 2017 at 10:44:57 AM by AutoGen 5.18.5
 .\"  From the definitions    ntpdc-opts.def
 .\"  and the template file   agmdoc-cmd.tpl
 .Sh NAME
@@ -787,7 +787,7 @@
 .Sh AUTHORS
 The formatting directives in this document came from FreeBSD.
 .Sh "COPYRIGHT"
-Copyright (C) 1992\-2016 The University of Delaware and Network Time Foundation all rights reserved.
+Copyright (C) 1992\-2017 The University of Delaware and Network Time Foundation all rights reserved.
 This program is released under the terms of the NTP license, <http://ntp.org/license>.
 .Sh BUGS
 The
Index: contrib/ntp/ntpd/ntp.conf.man.in
===================================================================
--- contrib/ntp/ntpd/ntp.conf.man.in	(版本 314126)
+++ contrib/ntp/ntpd/ntp.conf.man.in	(版本 316722)
@@ -10,11 +10,11 @@
 .ds B-Font B
 .ds I-Font I
 .ds R-Font R
-.TH ntp.conf 5 "21 Nov 2016" "4.2.8p9" "File Formats"
+.TH ntp.conf 5 "21 Mar 2017" "4.2.8p10-beta" "File Formats"
 .\"
-.\" EDIT THIS FILE WITH CAUTION (/tmp/.ag-Q_ai3f/ag-2_aa2f)
+.\" EDIT THIS FILE WITH CAUTION (/tmp/.ag-UAaqtC/ag-6AaisC)
 .\"
-.\" It has been AutoGen-ed November 21, 2016 at 08:01:41 AM by AutoGen 5.18.5
+.\" It has been AutoGen-ed March 21, 2017 at 10:30:48 AM by AutoGen 5.18.5
 .\" From the definitions ntp.conf.def
 .\" and the template file agman-cmd.tpl
 .SH NAME
@@ -3182,7 +3182,7 @@
 .SH "AUTHORS"
 The University of Delaware and Network Time Foundation
 .SH "COPYRIGHT"
-Copyright (C) 1992-2016 The University of Delaware and Network Time Foundation all rights reserved.
+Copyright (C) 1992-2017 The University of Delaware and Network Time Foundation all rights reserved.
 This program is released under the terms of the NTP license, <http://ntp.org/license>.
 .SH BUGS
 The syntax checking is not picky; some combinations of
